import type Firebase from "firebase";
import { Task, TaskLog, TaskStatus, TaskAttempt, TaskDefinition, TaskInvocation } from "@dotdev/taskify-shared";
export declare const useTasks: (options?: {
    limit?: number;
    status?: TaskStatus;
    taskTypes?: string[];
}) => {
    tasks: import("react-firebase-hooks/firestore/dist/firestore/types").Data<Task, "id", "ref">[] | undefined;
    loading: boolean;
    error: Firebase.FirebaseError | undefined;
    nextPage: () => void;
    hasNextPage: boolean;
    prevPage: () => void;
    hasPrevPage: boolean;
};
export declare const useTask: (taskRef?: Firebase.firestore.DocumentReference<Firebase.firestore.DocumentData> | undefined) => {
    task: import("react-firebase-hooks/firestore/dist/firestore/types").Data<Task, "id", "ref"> | undefined;
    loading: boolean;
    error: Firebase.FirebaseError | undefined;
};
export declare const useTaskAttempts: (taskRef?: Firebase.firestore.DocumentReference<Firebase.firestore.DocumentData> | undefined) => {
    taskAttempts: import("react-firebase-hooks/firestore/dist/firestore/types").Data<TaskAttempt, "id", "ref">[] | undefined;
    loading: boolean;
    error: Firebase.FirebaseError | undefined;
};
export declare const useTaskLogs: (taskAttemptRef?: Firebase.firestore.DocumentReference<Firebase.firestore.DocumentData> | undefined) => {
    taskLogs: import("react-firebase-hooks/firestore/dist/firestore/types").Data<TaskLog, "id", "ref">[] | undefined;
    loading: boolean;
    error: Firebase.FirebaseError | undefined;
};
export declare const useRunTask: (taskDefinition: TaskDefinition) => (params?: Record<string, any> | undefined, options?: {
    openModal?: boolean | undefined;
} | undefined) => Promise<{
    taskRef: Firebase.firestore.DocumentReference<Task>;
    taskAttemptRef: Firebase.firestore.DocumentReference<TaskAttempt>;
    taskInvocationRef: Firebase.firestore.DocumentReference<TaskInvocation>;
}>;
export declare const useRetryTask: (taskRef?: Firebase.firestore.DocumentReference<Task> | undefined) => () => Promise<{
    taskAttemptRef: Firebase.firestore.DocumentReference<TaskAttempt>;
    taskInvocationRef: Firebase.firestore.DocumentReference<TaskInvocation>;
} | undefined>;
export declare const useViewTask: () => (taskRef: Firebase.firestore.DocumentReference<Task>) => void;
export declare const useViewTaskPath: () => (taskPath: string) => void;
